;/////////////////////////////////////////////////////////
;//			CLEAR PROJECTS VISUALSTUDIO 
;//			ini: 26.02.12 -  end: 01.03.12
;//			BY RHL ( oprhl@hotmail.com)
;/////////////////////////////////////////////////////////

.386
.model flat, stdcall 
option casemap :none

include app 0x10.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov		Myh,eax

    invoke InitCommonControls
	invoke DialogBoxParam,Myh,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0
	
DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
		Mov eax,uMsg

;//	MESSAGE WM_INITDIALOG ////////////////////////////////////////
		cmp eax,WM_INITDIALOG
		jne win_msg1
		invoke GetDlgItem, hWin, TXTB_ADD
		mov HwTxtAdd,eax
		invoke GetDlgItem, hWin, LBL_NAMEP
		mov HwLblN,eax
;//	MESSAGE WM_COMMAND ///////////////////////////////////////////
win_msg1:
		cmp eax,WM_COMMAND
		jne win_msg2
		mov edx,wParam
		;// LOAD PROJECT? ///////////////////////////////////////
		cmp edx,CMD_LOAD		
		jne button_clear_pro
		invoke FindWindow,NULL,addr NAMET
		; // we estableced struct
		mov InfProject.hWndOwner,eax
		mov InfProject.lpszTitle,offset DRIVEC
		mov InfProject.ulFlags,BIF_RETURNONLYFSDIRS
		invoke SHBrowseForFolder,addr InfProject
		;// cancel button? or error? 
		cmp eax,NULL
		je end_if_
		invoke SHGetPathFromIDList,eax,addr pathproject
		invoke CoTaskMemFree,eax
		mov edi,offset SLNVS
		mov esi,offset pathproject
		push edi
		push esi
		call GetNameProject
		jmp end_if_
button_clear_pro:
		;// CLEAR PROJECT? //////////////////////////////////////
		cmp edx,CMD_CLEAR		
		jne checks_proc
		;// check buffer pathproject
		mov eax,dword ptr pathproject
		cmp eax,0
		je msg_err
		call SetExt
		mov esi,offset heapAddExt
		mov edi,offset pathproject
		push esi
		push edi
		call FindFiles
		jmp end_if_
checks_proc:		
		;// CLICKS CHECKS? /////////////////////////////////////
		movzx eax,dx
		mov ecx,edx
		shr	ecx,16
		cmp ecx,BN_CLICKED
		jne button_end
		push eax
		call pCheck
		jmp end_if_
button_end:	
		;// END? //////////////////////////////////////////////
		cmp edx,CMD_END			
		jne button_check_boxs
		jmp end_proc
button_check_boxs:		
		push edx
		call pCheck
		cmp eax,0
		jne else_
		jmp end_if_
;//	MESSAGE WM_CLOSE ///////////////////////////////////////////
win_msg2:
		cmp eax,WM_CLOSE
		jne else_
end_proc:
		invoke EndDialog,hWin,NULL
		jmp end_if_
;// ELSE... ////////////////////////////////////////////////////
else_:	
		mov eax,FALSE
		ret
;// MESSAGEBOX ERROR... ////////////////////////////////////////
msg_err:	
		invoke MessageBox,0,addr ERRORT,addr ERRORT,MB_OK
;// END IF... //////////////////////////////////////////////////
end_if_:		
		mov eax,TRUE
		ret
DlgProc endp


;// param1: handle of checkbox 
pCheck proc
	push edx
	mov edx,[esp+08h]
	mov eax,01h
	;////////////////////////////////////////////////////////////////////
	; if 0 = FALSE  else TRUE
	;////////////////////////////////////////////////////////////////////
	cmp edx,1050		;// check 1
	jne	check2
	not [CHECKS]
	jmp end_check	
check2:	
	cmp edx,1051
	jne	check3
	not [CHECKS+1]
	jmp end_check	
check3:
	cmp edx,1052
	jne	check4
	not [CHECKS+2]
	jmp end_check
check4:
	cmp edx,1053
	jne	check5
	not [CHECKS+3]
	jmp end_check
check5:
	cmp edx,1054
	jne	check6
	not [CHECKS+4]
	jmp end_check
check6:
	cmp edx,1055
	jne	check7
	not [CHECKS+5]
	jmp end_check
check7:
	cmp edx,1056
	jne	check8
	not [CHECKS+6]
	jmp end_check
check8:
	cmp edx,1057
	jne	check9
	not [CHECKS+7]
	jmp end_check
check9:
	cmp edx,1058
	jne	check10
	not [CHECKS+8]
	jmp end_check
check10:
	cmp edx,1059
	jne	check11
	not [CHECKS+9]
	jmp end_check
check11:
	cmp edx,1060
	jne	check12
	not [CHECKS+0ah]	
	jmp end_check
check12:
	cmp edx,1061
	jne	check13
	not [CHECKS+0bh]
	jmp end_check
check13:
	cmp edx,1062
	jne	check14
	not [CHECKS+0ch]
	jmp end_check
check14:
	cmp edx,1063
	jne	no_found
	not [CHECKS+0dh]
	jmp end_check
no_found:
	mov eax,0
end_check:
	pop edx
	ret
pCheck endp

;// stableced buffer for extentions
SetExt proc
	push ebp
	mov ebp,esp
	;// local variable( ebp-04 > stored length, ebp-08 > for store address of check 14  ) 
	sub esp,08h
	push edx
	push edi
	push esi
	push ecx
	mov ecx,0bh
	mov edi,offset heapAddExt
	mov edx,offset CHECKS
	mov eax,offset CHECKS+0bh
	mov [ebp-08],eax		;// stored pointer to check 14 (added extension?)
	mov esi,offset DefaultTypes
	;// edi = pointer to heapAddExt 
	;// esi = pointer to defaultypes
	;// edx = pointer to array of value boolean
	;// al = value boolean of each array 
loop_for_checks:
	push 3bh				;// character to find
	push esi
	call dInStr
	inc eax
	mov [ebp-04h],eax		;// stored legnth
	mov al,byte ptr [edx]	;// get value boolean
	cmp al,0				;// enable? ( 0 = false check , else true )
	je next_c				;// jump to increment pointer to array ( next check )
	cmp edx,[ebp-08]		;// check 14?
	jne no_add
	push ecx
	;// get date textbox add extensions
	invoke SendMessage,HwTxtAdd,WM_GETTEXT,100,edi
	pop ecx
	jmp next_c
no_add:
	mov eax,[ebp-04h]
	push eax
	push esi
	push edi
	call Memcpy
	mov eax,[ebp-04h]
	add edi,eax
next_c:
	inc edx
	add esi,[ebp-04h]		;// sum offset next type file
	loop loop_for_checks
	pop ecx
	pop esi
	pop edi
	pop edx
	mov esp,ebp
	pop ebp
	ret
SetExt endp

;// procedure to get name of project
;// param1: pointer to buffer path
;// param2: pointer to buffer with file type
;// procedure with format _stdcall
GetNameProject proc
	push ebp
	mov ebp,esp
	sub esp,04h				;// local variable ( ebp-04)
	push edx
	push ebx
	mov edx,[ebp+08]		;// edx = pointer to path
	mov [ebp-04],edx		;// store pointer
	push 0
	push edx
	call dInStr
	mov lenPathProject,eax	;// stored length of path project 
	add edx,eax
	mov bl,subdir
	mov [edx],bl
	inc edx
	mov eax,[ebp+0ch]		;// eax = pointer to extension
	push 05h
	push eax
	push edx
	call Memcpy
	mov edx,[ebp-04]		;// restore pointer
	invoke FindFirstFile,edx,addr FData
	mov ebx,eax				;// edx = handle of search
	;// show name of projects to label control
	invoke SendMessage,HwLblN,WM_SETTEXT, 0, addr FData.cFileName
	invoke FindClose,ebx
	pop ebx
	pop edx
	mov esp,ebp
	pop ebp
	ret
GetNameProject endp

;// param1: pointer to buffer path
;// param2: pointer to buffer with files type
;// procedure with format _STDCALL
FindFiles proc
	push ebp
	mov ebp,esp
	;// variables locales: Handle Search ( ebp-04h = store length type file )
	sub esp,04h
	push esi
	push edi
	push edx
	mov edi,[ebp+08h]		;// ebp+8h = pointer to buffer path ( edi )	
	add edi,lenPathProject
	mov dl,subdir
	mov [edi],dl
	inc edi					;// pointer to free byte
	mov esi,[ebp+0ch]		;// ebp+0ch = pointer to buffer exten ( esi)
	;// loop extensiones
loop_ext:
	push 3bh
	push esi
	call dInStr				;// get length of file type
	cmp eax,0
	je end_search
	mov [ebp-04],eax		;// stored length
	push eax
	push esi
	push offset typetmp
	call Memcpy				;// copy to new buffer ( type file )
	mov  eax,lenPathProject	
	inc eax
	push [ebp-04]			;// length of file type
	push offset typetmp		;// pointer to file type
	push eax				;// length of path
	push [ebp+08]			;// pointer to buffer path
	call findfilestype
	inc esi
	add esi,[ebp-04]
	jmp loop_ext
end_search:
	pop edx
	pop edi
	pop esi
	mov esp,ebp
	;add esp,08h
	pop ebp
	ret 08h
FindFiles endp


findfilestype proc mypath:DWORD, lengthP:DWORD, lpftype:DWORD, lengthftype:DWORD
	LOCAL mBOOL:BYTE
	LOCAL nextfile:BYTE
	LOCAL findhandle:DWORD
	LOCAL lengthDir:DWORD
	LOCAL addresswrite:DWORD

	mov edx,mypath
	add edx,lengthP				
	mov addresswrite,edx		;// address for write date
	mov edi,lengthftype			
	inc edi
	push edi
	push lpftype
	push addresswrite
	call Memcpy
	
	invoke FindFirstFile,mypath,addr FData
	mov findhandle,eax
	.if eax != INVALID_HANDLE_VALUE
		mov eax,TRUE
		mov nextfile,al
		.while nextfile
			mov ebx,offset FData.cFileName
			push 0
			push ebx
			call dInStr
			inc eax						;// also null character
			push eax
			push ebx
			push addresswrite
			call Memcpy
			push mypath
			call KillFile
			invoke FindNextFile,findhandle,addr FData
			.if eax == FALSE
				mov nextfile,al
			.endif
		.endw
		invoke FindClose,findhandle
	.endif
	push 02h
	push offset chardir
	push addresswrite
	call Memcpy 
	invoke FindFirstFile,mypath,addr FData
	.if eax != INVALID_HANDLE_VALUE
		mov findhandle,eax
		mov mBOOL,1
		.while mBOOL > FALSE
			mov dx,WORD ptr FData.cFileName
			.if dx != 2eh && dx != 2e2eh 
				push 0
				push offset FData.cFileName
				call dInStr						;// get length name dir
				mov lengthDir,eax				;// store length
				inc eax							;/ add null character
				push eax
				push offset FData.cFileName
				push addresswrite
				call Memcpy
				invoke GetFileAttributes,mypath
				.if eax == FILE_ATTRIBUTE_DIRECTORY
					mov ebx,lengthP
					add ebx,lengthDir
					mov edx,mypath
					add edx,ebx
					mov al,subdir
					mov [edx],al				;// write subDir '\'
					inc ebx
					push lengthftype
					push lpftype
					push ebx
					push mypath
					call findfilestype
				.endif
			.endif			
			invoke FindNextFile,findhandle,offset FData
			mov mBOOL,al
		.endw
		invoke FindClose,findhandle
	.endif
	ret

findfilestype endp

KillFile proc
	push edx
	mov edx,[esp+08h]
	invoke DeleteFile,edx
	pop edx
	ret 04h
KillFile endp

;// procedure copy n bytes to at operand destiny
;// param1: pointer destiny
;// param2: pointer source
;// param3: num. bytes to copy
;// procedure _STDCALL
Memcpy proc
	push ebp
	mov ebp,esp
	push esi
	push edi
	push ecx
	mov edi,[ebp+08h]
	mov esi,[ebp+0ch]
	mov ecx,[ebp+10h]
lo:	mov al,[esi]
	mov [edi],al
	inc esi
	inc edi
	loop lo
	pop ecx
	pop edi
	pop esi
	pop ebp
	ret 0ch
Memcpy endp

;// param1 : pointer to buffer for search charcter
;// param2 : charcter
;// Find a byte in the buffer string, return the position in byte zero if this is found... 
;// procedure format _STDCALL
dInStr proc
	push ebp
	mov ebp,esp
	push edx
	push esi
	push ebx
	xor edx,edx
	xor eax,eax
	mov esi,[ebp+08h]
	mov bl,[ebp+0ch]
lo:	mov dl,Byte ptr [esi]
	cmp dl,bl
	je fo
	cmp dl,0
	je fo
	inc esi
	inc eax
	jmp lo
fo:	pop ebx
	pop esi
	pop edx
	pop ebp
	ret 08h
dInStr endp

end start

